//
// SWIG typemaps for STL - common utilities
// Luigi Ballabio
// Aug 3, 2002
//
// Support for mzscheme 30x added 
// Hans Oesterholt
// hdnews -at- gawab -dot- com
// 2005-03-28
//
// MzScheme implementation

#ifndef SCHEME_STR_VAL 
/* 
 * This is MZSCHEME 299.100 or higher (30x).
 * From version 299.100 of mzscheme upwards,
 * strings are in unicode. These functions convert
 * to and from utf8 encodings of these strings.
 * NB! strlen(s) will be the size in bytes of
 * the string, not the actual length.
 */
#define SCHEME_STR_VAL(obj)  	SCHEME_BYTE_STR_VAL(scheme_char_string_to_byte_string(obj))
#define SCHEME_STRINGP(obj)     SCHEME_CHAR_STRINGP(obj)
#define scheme_make_string(s)   scheme_make_utf8_string(s)
#endif

%apply size_t { std::size_t };

%{
#include <string>

std::string swig_scm_to_string(Scheme_Object* x) {
    return std::string(SCHEME_STR_VAL(x));
}
Scheme_Object* swig_make_string(const std::string& s) {
    return scheme_make_string(s.c_str());
}
%}
